Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/DampenedModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/DampenedModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/DampenedModel.cs	(revision 16892)
@@ -0,0 +1,124 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  //mulitdimensional extension of http://www2.stat.duke.edu/~tjl13/s101/slides/unit6lec3H.pdf
+  [StorableType("42E9766F-207F-47B1-890C-D5DFCF469838")]
+  public class DampenedModel : RegressionModel {
+    [Storable]
+    protected IRegressionModel Model;
+    [Storable]
+    private double Min;
+    [Storable]
+    private double Max;
+    [Storable]
+    private double Dampening;
+
+    [StorableConstructor]
+    protected DampenedModel(StorableConstructorFlag _) : base(_) { }
+    protected DampenedModel(DampenedModel original, Cloner cloner) : base(original, cloner) {
+      Model = cloner.Clone(original.Model);
+      Min = original.Min;
+      Max = original.Max;
+      Dampening = original.Dampening;
+    }
+    protected DampenedModel(IRegressionModel model, IRegressionProblemData pd, double dampening) : base(model.TargetVariable) {
+      Model = model;
+      Min = pd.TargetVariableTrainingValues.Min();
+      Max = pd.TargetVariableTrainingValues.Max();
+      Dampening = dampening;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DampenedModel(this, cloner);
+    }
+
+    public static IConfidenceRegressionModel DampenModel(IConfidenceRegressionModel model, IRegressionProblemData pd, double dampening) {
+      return new ConfidenceDampenedModel(model, pd, dampening);
+    }
+    public static IRegressionModel DampenModel(IRegressionModel model, IRegressionProblemData pd, double dampening) {
+      var cmodel = model as IConfidenceRegressionModel;
+      return cmodel != null ? new ConfidenceDampenedModel(cmodel, pd, dampening) : new DampenedModel(model, pd, dampening);
+    }
+
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get { return Model.VariablesUsedForPrediction; }
+    }
+
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      var slow = Sigmoid(-Dampening);
+      var shigh = Sigmoid(Dampening);
+      foreach (var x in Model.GetEstimatedValues(dataset, rows)) {
+        var y = Rescale(x, Min, Max, -Dampening, Dampening);
+        y = Sigmoid(y);
+        y = Rescale(y, slow, shigh, Min, Max);
+        yield return y;
+      }
+    }
+
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+
+    private static double Rescale(double x, double oMin, double oMax, double nMin, double nMax) {
+      var d = oMax - oMin;
+      var nd = nMax - nMin;
+      if (d.IsAlmost(0)) {
+        d = 1;
+        nMin += nd / 2;
+        nd = 0;
+      }
+      return ((x - oMin) / d) * nd + nMin;
+    }
+
+    private static double Sigmoid(double x) {
+      return 1 / (1 + Math.Exp(-x));
+    }
+
+
+    [StorableType("CCC93BEC-8796-4D8E-AC58-DD175073A79B")]
+    private sealed class ConfidenceDampenedModel : DampenedModel, IConfidenceRegressionModel {
+      #region HLConstructors
+      [StorableConstructor]
+      private ConfidenceDampenedModel(StorableConstructorFlag _) : base(_) { }
+      private ConfidenceDampenedModel(ConfidenceDampenedModel original, Cloner cloner) : base(original, cloner) { }
+      public ConfidenceDampenedModel(IConfidenceRegressionModel model, IRegressionProblemData pd, double dampening) : base(model, pd, dampening) { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new ConfidenceDampenedModel(this, cloner);
+      }
+      #endregion
+
+      public IEnumerable<double> GetEstimatedVariances(IDataset dataset, IEnumerable<int> rows) {
+        return ((IConfidenceRegressionModel)Model).GetEstimatedVariances(dataset, rows);
+      }
+
+      public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+        return new ConfidenceRegressionSolution(this, problemData);
+      }
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/PreconstructedLinearModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/PreconstructedLinearModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafModels/PreconstructedLinearModel.cs	(revision 16892)
@@ -0,0 +1,153 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  //mulitdimensional extension of http://www2.stat.duke.edu/~tjl13/s101/slides/unit6lec3H.pdf
+  [StorableType("15F2295C-28C1-48C3-8DCB-9470823C6734")]
+  internal sealed class PreconstructedLinearModel : RegressionModel {
+    [Storable]
+    public Dictionary<string, double> Coefficients { get; private set; }
+    [Storable]
+    public double Intercept { get; private set; }
+
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get { return Coefficients.Keys; }
+    }
+
+    #region HLConstructors
+    [StorableConstructor]
+    private PreconstructedLinearModel(StorableConstructorFlag _) : base(_) { }
+    private PreconstructedLinearModel(PreconstructedLinearModel original, Cloner cloner) : base(original, cloner) {
+      if (original.Coefficients != null) Coefficients = original.Coefficients.ToDictionary(x => x.Key, x => x.Value);
+      Intercept = original.Intercept;
+    }
+    public PreconstructedLinearModel(Dictionary<string, double> coefficients, double intercept, string targetvariable) : base(targetvariable) {
+      Coefficients = new Dictionary<string, double>(coefficients);
+      Intercept = intercept;
+    }
+    public PreconstructedLinearModel(double intercept, string targetvariable) : base(targetvariable) {
+      Coefficients = new Dictionary<string, double>();
+      Intercept = intercept;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PreconstructedLinearModel(this, cloner);
+    }
+    #endregion
+
+    public static PreconstructedLinearModel CreateLinearModel(IRegressionProblemData pd, out double rmse) {
+      return AlternativeCalculation(pd, out rmse);
+    }
+
+    private static PreconstructedLinearModel ClassicCalculation(IRegressionProblemData pd) {
+      var inputMatrix = pd.Dataset.ToArray(pd.AllowedInputVariables.Concat(new[] {
+        pd.TargetVariable
+      }), pd.AllIndices);
+
+      var nFeatures = inputMatrix.GetLength(1) - 1;
+      double[] coefficients;
+
+      alglib.linearmodel lm;
+      alglib.lrreport ar;
+      int retVal;
+      alglib.lrbuild(inputMatrix, inputMatrix.GetLength(0), nFeatures, out retVal, out lm, out ar);
+      if (retVal != 1) throw new ArgumentException("Error in calculation of linear regression solution");
+
+      alglib.lrunpack(lm, out coefficients, out nFeatures);
+      var coeffs = pd.AllowedInputVariables.Zip(coefficients, (s, d) => new {s, d}).ToDictionary(x => x.s, x => x.d);
+      var res = new PreconstructedLinearModel(coeffs, coefficients[nFeatures], pd.TargetVariable);
+      return res;
+    }
+
+    private static PreconstructedLinearModel AlternativeCalculation(IRegressionProblemData pd, out double rmse) {
+      var variables = pd.AllowedInputVariables.ToList();
+      var n = variables.Count;
+      var m = pd.TrainingIndices.Count();
+
+      //Set up X^T
+      var inTr = new double[n + 1, m];
+      for (var i = 0; i < n; i++) {
+        var vdata = pd.Dataset.GetDoubleValues(variables[i], pd.TrainingIndices).ToArray();
+        for (var j = 0; j < m; j++) inTr[i, j] = vdata[j];
+      }
+      for (var i = 0; i < m; i++) inTr[n, i] = 1;
+
+      //Set up y
+      var y = new double[m, 1];
+      var ydata = pd.TargetVariableTrainingValues.ToArray();
+      for (var i = 0; i < m; i++) y[i, 0] = ydata[i];
+
+      //Perform linear regression
+      var aTy = new double[n + 1, 1];
+      var aTa = new double[n + 1, n + 1];
+      var aTyVector = new double[n + 1];
+      int info;
+      alglib.densesolverreport report;
+      double[] coefficients;
+
+      //Perform linear regression
+      alglib.rmatrixgemm(n + 1, 1, m, 1, inTr, 0, 0, 0, y, 0, 0, 0, 0, ref aTy, 0, 0); //aTy = inTr * y;
+      alglib.rmatrixgemm(n + 1, n + 1, m, 1, inTr, 0, 0, 0, inTr, 0, 0, 1, 0, ref aTa, 0, 0); //aTa = inTr * t(inTr) +aTa //
+      alglib.spdmatrixcholesky(ref aTa, n + 1, true);
+      for (var i = 0; i < n + 1; i++) aTyVector[i] = aTy[i, 0];
+      alglib.spdmatrixcholeskysolve(aTa, n + 1, true, aTyVector, out info, out report, out coefficients);
+
+      //if Cholesky calculation fails fall back to classic linear regresseion 
+      if (info != 1) {
+        alglib.linearmodel lm;
+        alglib.lrreport ar;
+        int retVal;
+        var inputMatrix = pd.Dataset.ToArray(pd.AllowedInputVariables.Concat(new[] {
+          pd.TargetVariable
+        }), pd.AllIndices);
+        alglib.lrbuild(inputMatrix, inputMatrix.GetLength(0), n, out retVal, out lm, out ar);
+        if (retVal != 1) throw new ArgumentException("Error in calculation of linear regression solution");
+        alglib.lrunpack(lm, out coefficients, out n);
+      }
+
+      var coeffs = Enumerable.Range(0, n).ToDictionary(i => variables[i], i => coefficients[i]);
+      var model = new PreconstructedLinearModel(coeffs, coefficients[n], pd.TargetVariable);
+      rmse = pd.TrainingIndices.Select(i => pd.Dataset.GetDoubleValue(pd.TargetVariable, i) - model.GetEstimatedValue(pd.Dataset, i)).Sum(r => r * r) / m;
+      rmse = Math.Sqrt(rmse);
+      return model;
+    }
+
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      return rows.Select(row => GetEstimatedValue(dataset, row));
+    }
+
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+
+    #region helpers
+    private double GetEstimatedValue(IDataset dataset, int row) {
+      return Intercept + (Coefficients.Count == 0 ? 0 : Coefficients.Sum(s => s.Value * dataset.GetDoubleValue(s.Key, row)));
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComplexLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComplexLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComplexLeaf.cs	(revision 16892)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("F34A0ED9-2CF6-4DEE-850D-08790663B66D")]
+  [Item("ComplexLeaf", "A leaf type that uses an arbitrary RegressionAlgorithm to create leaf models")]
+  public sealed class ComplexLeaf : LeafBase {
+    public const string RegressionParameterName = "Regression";
+    public IValueParameter<IDataAnalysisAlgorithm<IRegressionProblem>> RegressionParameter {
+      get { return (IValueParameter<IDataAnalysisAlgorithm<IRegressionProblem>>)Parameters[RegressionParameterName]; }
+    }
+    public IDataAnalysisAlgorithm<IRegressionProblem> Regression {
+      get { return RegressionParameter.Value; }
+      set { RegressionParameter.Value = value; }
+    }
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    private ComplexLeaf(StorableConstructorFlag _) : base(_) { }
+    private ComplexLeaf(ComplexLeaf original, Cloner cloner) : base(original, cloner) { }
+    public ComplexLeaf() {
+      var regression = new KernelRidgeRegression();
+      Parameters.Add(new ValueParameter<IDataAnalysisAlgorithm<IRegressionProblem>>(RegressionParameterName, "The algorithm creating RegressionModels", regression));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ComplexLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return false; }
+    }
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int noParameters) {
+      if (pd.Dataset.Rows < MinLeafSize(pd)) throw new ArgumentException("The number of training instances is too small to create a linear model");
+      noParameters = pd.Dataset.Rows + 1;
+      Regression.Problem = new RegressionProblem { ProblemData = pd };
+      var res = RegressionTreeUtilities.RunSubAlgorithm(Regression, random.Next(), cancellationToken);
+      var t = res.Select(x => x.Value).OfType<IRegressionSolution>().FirstOrDefault();
+      if (t == null) throw new ArgumentException("No RegressionSolution was provided by the algorithm");
+      return t.Model;
+    }
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return 3;
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComponentReductionLinearLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComponentReductionLinearLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ComponentReductionLinearLeaf.cs	(revision 16892)
@@ -0,0 +1,90 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("5730B54C-7A8B-4CA7-8F37-7FF3F9848CD2")]
+  [Item("ComponentReductionLinearLeaf", "A leaf type that uses principle component analysis to create smaller linear models as leaf models")]
+  public class ComponentReductionLinearLeaf : LeafBase {
+    public const string NumberOfComponentsParameterName = "NoComponents";
+    public IFixedValueParameter<IntValue> NumberOfCompontentsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters[NumberOfComponentsParameterName]; }
+    }
+    public int NumberOfComponents {
+      get { return NumberOfCompontentsParameter.Value.Value; }
+      set { NumberOfCompontentsParameter.Value.Value = value; }
+    }
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected ComponentReductionLinearLeaf(StorableConstructorFlag _) : base(_) { }
+    protected ComponentReductionLinearLeaf(ComponentReductionLinearLeaf original, Cloner cloner) : base(original, cloner) { }
+    public ComponentReductionLinearLeaf() {
+      Parameters.Add(new FixedValueParameter<IntValue>(NumberOfComponentsParameterName, "The maximum number of principle components used (default=10)", new IntValue(10)));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ComponentReductionLinearLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return false; }
+    }
+
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random,
+      CancellationToken cancellationToken, out int numberOfParameters) {
+      var pca = PrincipleComponentTransformation.CreateProjection(pd.Dataset, pd.TrainingIndices, pd.AllowedInputVariables, normalize: true);
+      var pcdata = pca.TransformProblemData(pd);
+      ComponentReducedLinearModel bestModel = null;
+      var bestCvrmse = double.MaxValue;
+      numberOfParameters = 1;
+      for (var i = 1; i <= Math.Min(NumberOfComponents, pd.AllowedInputVariables.Count()); i++) {
+        var pd2 = (IRegressionProblemData)pcdata.Clone();
+        var inputs = new HashSet<string>(pca.ComponentNames.Take(i));
+        foreach (var v in pd2.InputVariables.CheckedItems.ToArray())
+          pd2.InputVariables.SetItemCheckedState(v.Value, inputs.Contains(v.Value.Value));
+        double rmse;
+        var model = PreconstructedLinearModel.CreateLinearModel(pd2, out rmse);
+        if (rmse > bestCvrmse) continue;
+        bestModel = new ComponentReducedLinearModel(pd2.TargetVariable, model, pca);
+        numberOfParameters = i + 1;
+        bestCvrmse = rmse;
+      }
+      return bestModel;
+    }
+
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return NumberOfComponents + 2;
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ConstantLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ConstantLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/ConstantLeaf.cs	(revision 16892)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("F3E94907-C5FF-4658-A870-8013C61DD2E1")]
+  [Item("ConstantLeaf", "A leaf type that uses constant models as leaf models")]
+  public class ConstantLeaf : LeafBase {
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected ConstantLeaf(StorableConstructorFlag _) : base(_) { }
+    protected ConstantLeaf(ConstantLeaf original, Cloner cloner) : base(original, cloner) { }
+    public ConstantLeaf() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ConstantLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return false; }
+    }
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters) {
+      if (pd.Dataset.Rows < MinLeafSize(pd)) throw new ArgumentException("The number of training instances is too small to create a linear model");
+      numberOfParameters = 1;
+      return new PreconstructedLinearModel(pd.Dataset.GetDoubleValues(pd.TargetVariable).Average(), pd.TargetVariable);
+    }
+
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return 0;
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/GaussianProcessLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/GaussianProcessLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/GaussianProcessLeaf.cs	(revision 16892)
@@ -0,0 +1,111 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("852B9F7D-9C2B-4574-BB71-EE70106EA809")]
+  [Item("GaussianProcessLeaf", "A leaf type that uses Gaussian process models as leaf models.")]
+  public class GaussianProcessLeaf : LeafBase {
+    #region ParameterNames
+    public const string TriesParameterName = "Tries";
+    public const string RegressionParameterName = "Regression";
+    #endregion
+
+    #region ParameterProperties
+    public IFixedValueParameter<IntValue> TriesParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters[TriesParameterName]; }
+    }
+    public IValueParameter<GaussianProcessRegression> RegressionParameter {
+      get { return (IValueParameter<GaussianProcessRegression>)Parameters[RegressionParameterName]; }
+    }
+    #endregion
+
+    #region Properties
+    public int Tries {
+      get { return TriesParameter.Value.Value; }
+      set { TriesParameter.Value.Value = value; }
+    }
+    public GaussianProcessRegression Regression {
+      get { return RegressionParameter.Value; }
+      set { RegressionParameter.Value = value; }
+    }
+    #endregion
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected GaussianProcessLeaf(StorableConstructorFlag _) : base(_) { }
+    protected GaussianProcessLeaf(GaussianProcessLeaf original, Cloner cloner) : base(original, cloner) { }
+    public GaussianProcessLeaf() {
+      var gp = new GaussianProcessRegression();
+      gp.CovarianceFunctionParameter.Value = new CovarianceRationalQuadraticIso();
+      gp.MeanFunctionParameter.Value = new MeanLinear();
+
+      Parameters.Add(new FixedValueParameter<IntValue>(TriesParameterName, "Number of restarts (default = 10)", new IntValue(10)));
+      Parameters.Add(new ValueParameter<GaussianProcessRegression>(RegressionParameterName, "The algorithm creating Gaussian process models", gp));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GaussianProcessLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return true; }
+    }
+
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters) {
+      if (pd.Dataset.Rows < MinLeafSize(pd)) throw new ArgumentException("The number of training instances is too small to create a Gaussian process model");
+      Regression.Problem = new RegressionProblem { ProblemData = pd };
+      var cvscore = double.MaxValue;
+      GaussianProcessRegressionSolution sol = null;
+
+      for (var i = 0; i < Tries; i++) {
+        var res = RegressionTreeUtilities.RunSubAlgorithm(Regression, random.Next(), cancellationToken);
+        var t = res.Select(x => x.Value).OfType<GaussianProcessRegressionSolution>().FirstOrDefault();
+        var score = ((DoubleValue)res["Negative log pseudo-likelihood (LOO-CV)"].Value).Value;
+        if (score >= cvscore || t == null || double.IsNaN(t.TrainingRSquared)) continue;
+        cvscore = score;
+        sol = t;
+      }
+      Regression.Runs.Clear();
+      if (sol == null) throw new ArgumentException("Could not create Gaussian process model");
+
+      numberOfParameters = pd.Dataset.Rows + 1
+                           + Regression.CovarianceFunction.GetNumberOfParameters(pd.AllowedInputVariables.Count())
+                           + Regression.MeanFunction.GetNumberOfParameters(pd.AllowedInputVariables.Count());
+      return sol.Model;
+    }
+
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return 3;
+    }
+    #endregion
+  }
+}
